'use strict';

Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: 'Module' } });

const fs = require('fs');
const path = require('path');

const _interopDefaultLegacy = e => e && typeof e === 'object' && 'default' in e ? e : { default: e };

const fs__default = /*#__PURE__*/_interopDefaultLegacy(fs);
const path__default = /*#__PURE__*/_interopDefaultLegacy(path);

const methods = {
  "create-node"(...args) {
    Editor.Message.send("scene", "create-node", ...args);
  },
  async install() {
    const installPath = path__default.default.resolve(__dirname, "../../../xr-plugin/assets");
    if (!fs__default.default.existsSync(installPath + "/xr")) {
      const resourcePath = path__default.default.resolve(__dirname, "../packages/lib.zip");
      await Editor.Utils.File.unzip(resourcePath, installPath);
      Editor.Message.request("asset-db", "refresh-asset", "db://xr-plugin");
    }
  }
};
const load = function() {
  methods.install();
};
const unload = function() {
};

exports.load = load;
exports.methods = methods;
exports.unload = unload;
