import fs from 'fs';
import path from 'path';

export const methods = {
    'create-node'(...args: any) {
        Editor.Message.send('scene', 'create-node', ...args);
    },
    
    async install() {
        const installPath = path.resolve(__dirname, '../../../xr-plugin/assets');
        if (!fs.existsSync(installPath + '/xr')) {
            const resourcePath = path.resolve(__dirname, '../packages/lib.zip');
            await Editor.Utils.File.unzip(resourcePath, installPath);
            Editor.Message.request('asset-db', 'refresh-asset', 'db://xr-plugin');
        }
    },
};

/**
 * @en Hooks triggered after extension loading is complete
 * @zh 扩展加载完成后触发的钩子
 */
export const load = function() {
    methods.install();
};

/**
 * @en Hooks triggered after extension uninstallation is complete
 * @zh 完成扩展卸载后触发的钩子
 */
export const unload = function() {

};